#include <stdio.h>
#include <conio.h>

#include "viscore.h"   // VisSDK
#include "cv.hpp"      // OpenCV

main()
{
	CVisGrayByteImage gray;     // VisSDK
	CVisRGBAByteImage color;    // 

	printf("Reading gray image ...\n");
	if (!gray.FReadFile("gray.bmp"))
	{
		printf("Could not open gray image\n");
		return -1;
	}

	printf("Displaying input image");
	CVisImageWnd wgray(gray);	
	printf("Press any key to continue...\n");
	_getch();

	// Wrap VisSDK image to IplImage
	IplImage *piplgray = VisIplCreateImage(gray);
	// Create Output Image
	CvSize sz = {piplgray->width, piplgray->height};
	IplImage *piplthresh = cvCreateImage( sz, piplgray->depth, piplgray->nChannels);
	//Call OpenCV processing routines
	cvThreshold(piplgray, piplthresh, 100, 255, CV_THRESH_BINARY);			
	// Calls to VisIplCreateImage must be matched with calls to VisIplDeleteImage
	VisIplDeleteImage(piplgray);
	// Wrap IplImage to VisSDK
	CVisGrayByteImage threshAlias;
	threshAlias.Alias(piplthresh);

	printf("Displaying output image");
	CVisImageWnd wthresh(threshAlias);	
	printf("Press any key to continue...\n");
	_getch();

	printf("Writing Output image\n");
	if(!threshAlias.FWriteFile("thresh.bmp"))
	{
		printf("Could not save output image\n");
		return -1;
	}
	cvReleaseImage(&piplthresh);

	printf("Done\n");
	return 0;
}